<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import Vue from 'vue';
import { NextStepAlt } from '~/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import ResourcesHero from '~/components/resources/resources-hero.vue';
import {
  Card500,
  OnDemandDemos,
  UpcomingDemoSeries,
} from '~/components/gitlab-technical-demo-series/index.vue';
import BySolutionLink from '~/components/solutions/by-solution/by-solution-link.vue';

export default Vue.extend({
  components: {
    NextStepAlt,
    ResourcesHero,
    OnDemandDemos,
    UpcomingDemoSeries,
    Card500,
    BySolutionLink,
  },
  nuxtI18n: false,
  async asyncData({ $gitlabTechnicalDemoSeriesService }) {
    const { page } = await $gitlabTechnicalDemoSeriesService.getPage(
      `gitlab-technical-demo-series`,
    );

    return { page };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).page, this.$route.path);
  },
});
</script>

<template>
  <div>
    <component
      :is="component.name"
      v-for="component in page?.components"
      :key="component.name"
      :data="component.data"
      v-bind="component"
    ></component>
    <SlpContainer v-if="page?.resources">
      <SlpRow class="card500__container">
        <Card500
          v-for="card in page.resources.card"
          :key="card.internalName"
          :card="card.fields"
        />
      </SlpRow>
    </SlpContainer>
    <NextStepAlt class="slp-mt-160" />
  </div>
</template>

<style lang="scss" scoped>
.card500__container {
  gap: $spacing-32;
  flex-wrap: nowrap;
}

@media screen and (max-width: $breakpoint-md) {
  .card500__container {
    flex-wrap: wrap;
  }
}
</style>
